/**
 * sd webapp基础类库，依赖zepto.js,gmu.js
 * 默认都需加载，调用前缀[sd]
 */
;(function(){
	window['sd'] = {};
	
	
	sd.view = {
		pageWidth : $(window).width(),
		pageHeight : $(window).height(),
		bannerHeigth : null,
	
		init : function() {
			
		}
	};
	
	/**
	 * 常用ui效果实现方法
	 * <ul>
	 * 	<li>-推出式侧边栏菜单</li>
	 *  <li>-底部导航菜单栏</li>
	 * </ul>
	 */
	sd.ui = {
		/**
		 * 推出式菜单
		 * @param {Object} _eventSource
		 * @param {Object} menuHtml
		 */
		initMenupanel : function(_eventSource, menuHtml) {
			$("body").wrapInner("<div class='page'></div>");
			$("body").children(".page").wrapInner("<div class='ui-menu-wrapper'></div>");
			$("body").children(".page").append("<div id='menupanel'></div>");
			
			if (sd.isBlank(menuHtml))
				menuHtml = sd.genRelativePath("web/common/menupanel.html");
				
			$.get(menuHtml, function(data){
                $('#menupanel').html(data);
            });	
			
			$('#menupanel').panel({
		        contentWrap: $('.ui-menu-wrapper'),
		        swipeClose: true,
		        dismissible: true,
		        beforeopen: function(){
		            
		        },
		        open: function(){
		            //调整iscroll 的高度
		            var maxHeight = $(window).height();
		            $('#iscrollzoom').css("height", maxHeight).iScroll();
		        },
		        beforeclose: function(){
		            
		        }
		    });
			
			$(_eventSource).on("touchstart", function(){
	            $('#menupanel').panel('toggle', 'push', 'left');
	        });
		},
		/**
		 * 底部菜单栏
		 * @param {Object} items
		 * @param {Object} selectUrl
		 */
		initFooter : function(items, type) {
		
			var menuWidth = ($(window).width() - items - 1) / items;
	        var menuHeight = 55;
	        var menuContainer = $(".ui-toolbar-footer-wrap-box");
	        $(menuContainer).find("ul li").children("img")
	        	.css("width", menuHeight + "px")
	        	.css("height", menuHeight + "px");
	        var navigateIndex = window.sessionStorage.getItem("navigateIndex");
	        navigateIndex = navigateIndex == null ? 0 : navigateIndex;
	        
	        $("footer").find("ul li").on("touchstart",function(){
				if (navigateIndex == $(this).index())
					return;
	            var dispatchUrl = $(this).attr("url");
	            window.location.href = dispatchUrl;
	            $(this).children().attr("src", $(this).children().attr("selectedUrl"));
	            window.sessionStorage.setItem("navigateIndex", $(this).index());
	        });

			//采用动态获取html会导致页面加载延迟，效果不佳			
			/*if (type === 2) {
				$.get("../common/footer.html", function(data, itmes){
			        $(".ui-toolbar-footer").html(data);
			        var menuWidth = ($(window).width() - items - 1) / itmes;
			        var menuHeight = 55;
			        var menuContainer = $(".ui-toolbar-footer-wrap-box");
			        var navigateIndex = window.sessionStorage.getItem("navigateIndex");
			        navigateIndex = navigateIndex == null ? 0 : navigateIndex;
			        
			        $(menuContainer).css("background-size", $(window).width() + "px 55px");
			        $(menuContainer).find("ul li").eq(navigateIndex)
			        	.css("background", "#B52A40");
			        $(menuContainer).find("ul li").children("img")
			        	.css("width", menuHeight + "px")
			        	.css("height", menuHeight + "px");
			        
			        $("footer").find("ul li").on("touchstart",function(){
						if (navigateIndex == $(this).index())
							return;
			            var dispatchUrl = $(this).attr("url");
			            window.location.href = dispatchUrl;
			            //$(this).siblings().css("background", "none");
			            $(this).css("background", "#B52A40");
			            window.sessionStorage.setItem("navigateIndex", $(this).index());
			        });
		    	});
		    } else if (type === 2) {
		    	$.get("../common/footer.html", function(data, itmes){
			        $(".ui-toolbar-footer").html(data);
			        var menuWidth = ($(window).width() - items - 1) / itmes;
			        var menuHeight = 55;
			        var menuContainer = $(".ui-toolbar-footer-wrap-box");
			        var navigateIndex = window.sessionStorage.getItem("navigateIndex");
			        navigateIndex = navigateIndex == null ? 0 : navigateIndex;
			        
			        $(menuContainer).css("background-size", $(window).width() + "px 55px");
			        $(menuContainer).find("ul li").eq(navigateIndex)
			        	.children().attr("src", $(menuContainer).find("ul li").eq(navigateIndex).children().attr("selectedUrl"));
			        $(menuContainer).find("ul li").children("img")
			        	.css("width", menuHeight + "px")
			        	.css("height", menuHeight + "px");
			        
			        $(menuContainer).find("ul li").on("touchstart",function(){
						if (navigateIndex == $(this).index())
							return;
			            var dispatchUrl = $(this).attr("url");
			            window.location.href = dispatchUrl;
			            $(this).siblings().each(function(){
			            	$(this).children().attr("src", $(this).children().attr("normalUrl"));
			            });
			            $(this).children().attr("src", $(this).children().attr("selectedUrl"));
			            window.sessionStorage.setItem("navigateIndex", $(this).index());
			        });
		    	});
		    }*/
		}
	};
	
	/**
	 * 常用ui事件实现方法
	 * <ul>
	 * 	<li>-网页回退事件</li>
	 * </ul>
	 */
	sd.event = {
		options : {
			//事件源
			eventSource : $(".btn-back"),
			//事件触发目标对象 
			eventTarget : $(".btn-back"),
			//目标对象的属性 
			statusAttr : "background",
			//事件触发前
			//statusFront : "#41C396",
			//事件触发后
			//statusAfter : "#009B24"
		},
		/**
		 * 注册回退事件
		 * @param {Object} _options
		 */
		registerBackEvent : function(_options) {
			sd.copyProperties(_options, sd.event.options);
			var back = $(".btn-back");
			sd.event.options.eventSource = $(".btn-back");
			
			$(sd.event.options.eventSource).on("touchstart", function(){
		    	$(sd.event.options.eventSource).css(sd.event.options.statusAttr, 
					sd.event.options.statusFront);
		    }).on('touchend', function(e){
				$(sd.event.options.eventSource).css(sd.event.options.statusAttr, 
					sd.event.options.statusAfter);
				var backurl = $(this).attr("backurl");
				if (backurl != undefined) {
					window.location.href = backurl;
					return;
				}
		        if (window.AppConfig) {
		            webview.back();
		            return;
				} else {
		            window.history.go(-1);
		            return;
				}
			});
		}
	};
	
	/**
	 * 通用弹出框，引用页面需引用:
	 * common.js
	 * dialog.js
	 * dialog.css
	 * dialog.default.css
	 *
	 * 调用方式：
	 * sd.dialog.success(content);(content不填则取默认值)
	 * sd.dialog.warn(content);(content不填则取默认值)
	 * sd.dialog.error(content);(content不填则取默认值)
	 * sd.dialog.showShort(content);(content必填，会自动关闭，短暂显示)
	 * sd.dialog.showLong(content);(content必填，会自动关闭，较长时间显示)
	 */
	
	var tid;
	sd.dialog = {
		dialog_success : null,
		dialog_warn : null,
		dialog_error : null,
		msgBox : null,
		
	    success: function(content){
	        if (content != null && content != undefined && content != "") 
	            this.dialog_success.content(content);
	        this.dialog_success.open();
	    },
	    warn: function(content){
	        if (content != null && content != undefined && content != "") 
	            this.dialog_success.content(content);
	        this.dialog_success.open();
	    },
	    error: function(content){
	        if (content != null && content != undefined && content != "") 
	            this.dialog_success.content(content);
	        this.dialog_success.open();
	    },
	    
	    showShort: function(content){
	        if (content == "" || content == null || content == undefined) 
	            return false;
	        this.msgBox.content(content);
	        this.msgBox.open();
	        tid = setTimeout("sd.dialog.closeMsgBox(" + tid + ")", 1000);
	    },
		
		closeMsgBox: function(_tid) {
			this.msgBox.close();
			clearTimeout(_tid);
		},
	    
	    showLong: function(content){
	        if (content == "" || content == null || content == undefined) 
	            return false;
	        this.msgBox.content(content);
	        this.msgBox.open();
	        tid = setTimeout("sd.dialog.closeMsgBox(" + tid + ")", 3000);
	    },
	    
	    sdconfirm: function(content, positiveCallback, negativeCallback){
	        if (content == "" || content == null || content != undefined) 
	            return false;
	    },
		
		initDialog : function(){
		    this.dialog_success = gmu.Dialog({
		        buttons: {
		            '确定': function(){
		                this.close();
		            }
		        },
		        title: '<span>' + '提示' + '</span>',
		        content: '<span class="dialog-prompt" >操作成功!</span>',
		        autoOpen: false,
		        closeBtn: false,
		        mask: false,
		        height: 150,
		        width: 300
		    });
		    
		    
		    this.dialog_warn = gmu.Dialog({
		        buttons: {
		            '确定': function(){
		                this.close();
		            }
		        },
		        title: "<span class='ui-dialog-h3'>提示</span>",
		        content: '<img src=""><span class="dialog-prompt" >操作成功</span>',
		        autoOpen: false,
		        closeBtn: false,
		        mask: false,
		        height: 250,
		        width: 300
		    });
		    
		    this.dialog_error = gmu.Dialog({
		        buttons: {
		            '确定': function(){
		                this.close();
		            }
		        },
		        title: '<span>' + '提示' + '</span>',
		        content: '<img src=""><span class="dialog-prompt" >操作失败!</span>',
		        autoOpen: false,
		        closeBtn: false,
		        mask: false,
		        height: 120,
		        width: 300
		    });
		    
		    this.msgBox = gmu.Dialog({
		        buttons: {},
		        title: '<span>' + '提示' + '</span>',
		        content: '<span class="dialog-prompt" >操作成功!</span>',
		        autoOpen: false,
		        closeBtn: false,
		        mask: false,
		        height: 120,
		        width: 300
		    });
		    
		    $(".ui-dialog-title h3").css("margin-top", 0);
		    $(".ui-dialog").css("min-height", 100);
		    $(".dialog-prompt").parent().parent().find(".ui-dialog-btns").css("margin-top", 0);
		}
	};
	
	/**
	 * 本地组件调用接口 
	 */
	sd.native = {
		AppConfig : {
			getImei : function() {
				if (window.AppConfig)
					return window.AppConfig.getImei();
				else
					console.info("未找到可用的组件！");
			},
		
			getImis : function() {
				if (window.AppConfig)
					return window.AppConfig.getImis();
				else
					console.info("未找到可用的组件！");
			},
			
			getPhoneNumber : function() {
				if (window.AppConfig)
					return window.AppConfig.getPhoneNumber();
				else
					console.info("未找到可用的组件！");
			},
			
			getImsi : function() {
				if (window.AppConfig)
					return window.AppConfig.getImsi();
				else
					console.info("未找到可用的组件！");
			},
			
			getNetWork : function() {
				if (window.AppConfig)
					return window.AppConfig.getNetWork();
				else
					console.info("未找到可用的组件！");
			},
			
			getPhoneType : function() {
				if (window.AppConfig)
					return window.AppConfig.getPhoneType();
				else
					console.info("未找到可用的组件！");
			},
			
			getPhoneBrand : function() {
				if (window.AppConfig)
					return window.AppConfig.getPhoneBrand();
				else
					console.info("未找到可用的组件！");
			},
			
			getSdkVersion : function() {
				if (window.AppConfig)
					return window.AppConfig.getSdkVersion();
				else
					console.info("未找到可用的组件！");
			},
			
			getApiVersion : function() {
				if (window.AppConfig)
					return window.AppConfig.getApiVersion();
				else
					console.info("未找到可用的组件！");
			},
			
			getManufacturer : function() {
				if (window.AppConfig)
					return window.AppConfig.getManufacturer();
				else
					console.info("未找到可用的组件！");
			}
		},
		
		Camera : {
			/**
			 * outputWidth, outputHeight, cropX, cropY
			 * @param 图片输出宽度 outputWidth
			 * @param 图片输出高度 outputHeight
			 * @param 图片裁剪宽度 cropX
			 * @param 图片裁剪高度 cropY
			 * 可以通过输入参数指定图片的输出高度和宽度，如果需要裁剪可指定裁剪的高宽比例
			 * 如果不输入参数，则按默认不裁剪且输出默认的高宽
			 */
			takePicture : function() {
				if (window.Camera)
					if (arguments.length == 0)
						return window.Camera.takePicture();
					else if (arguments.length == 2)
						return window.Camera.takePicture(arguments[0], arguments[1]);
					else if (arguments.length == 3)
						return window.Camera.takePicture(arguments[0], arguments[1], arguments[2], arguments[3]);
				else
					console.info("未找到可用的组件！");
			},
			
			choosePicture : function() {
				if (window.Camera)
					if (arguments.length == 0)
						return window.Camera.choosePicture();
					else if (arguments.length == 2)
						return window.Camera.choosePicture(arguments[0], arguments[1]);
					else if (arguments.length == 3)
						return window.Camera.choosePicture(arguments[0], arguments[1], arguments[2], arguments[3]);
				else
					console.info("未找到可用的组件！");
			}			
		},
		
		Player : {
			startPlay : function(playFile) {
				if (window.Player)
					window.Player.startPlay(playFile);
				else
					console.info("未找到可用的组件！");
			},
			
			isPlaying : function() {
				if (window.Player)
					return window.Player.isPlaying();
				else
					console.info("未找到可用的组件！");
			},
			
			startPlayVoiceStream : function(streamPath) {
				if (window.Player)
					return window.Player.startPlayVoiceStream(streamPath);
				else
					console.info("未找到可用的组件！");
			},
			
			stopPlay : function() {
				if (window.Player)
					window.Player.stopPlay();
				else
					console.info("未找到可用的组件！");
			}
		},
		
		Poster : {
			post : function() {
				if (window.Poster)
					return window.Poster.post(params);
				else
					console.info("未找到可用的组件！");
			},
			
			asyncPost : function() {
				if (window.Poster)
					window.Poster.asyncPost(params, callback);
				else
					console.info("未找到可用的组件！");
			}
		},
		
		push : {
			pushLogin : function(userName, password) {
				if (window.push)
					window.push.pushLogin(userName, password);
				else
					console.info("未找到可用的组件！");
			},
			
			pushRegister : function(userName, password) {
				if (window.push)
					window.push.pushRegister(userName, password);
				else
					console.info("未找到可用的组件！");
			},
			
			openNotification : function() {
				if (window.push)
					window.push.openNotification();
				else
					console.info("未找到可用的组件！");
			},
	
			closeNotification : function() {
				if (window.push)
					window.push.closeNotification();
				else
					console.info("未找到可用的组件！");
			},
			
			openNotificationSound : function() {
				if (window.push)
					window.push.openNotificationSound();
				else
					console.info("未找到可用的组件！");
			},
			
			closeNotificationSound : function() {
				if (window.push)
					window.push.closeNotificationSound();
				else
					console.info("未找到可用的组件！");
			},
	
			notification : function() {
				if (window.push)
					return window.push.notification();
				else
					console.info("未找到可用的组件！");
			},
			
			notificationSound : function() {
				if (window.push)
					return window.push.notificationSound();
				else
					console.info("未找到可用的组件！");
			}
		},
		
		Recorder : {
			startRecord : function() {
				if (window.Recorder)
					window.Recorder.startRecord();
				else
					console.info("未找到可用的组件！");
			},
			
			stopRecord : function() {
				if (window.Recorder)
					window.Recorder.stopRecord();
				else
					console.info("未找到可用的组件！");
			},
			
			getCurrentRecordFilePath : function() {
				if (window.Recorder)
					window.Recorder.getCurrentRecordFilePath();
				else
					console.info("未找到可用的组件！");
			}
		},
		
		webview : {
			back : function() {
				if (window.webview) 
					window.webview.back();
				else
					console.info("未找到可用的组件！");
			}
		},
		
		Upgrade : {
			isUpgradeAvailable : function(checkUpgradeCallback) {
				if (window.Upgrade) 
					return window.Upgrade.isUpgradeAvailable(checkUpgradeCallback);
				else
					console.info("未找到可用的组件！");
			},
			
			startDownload : function() {
				if (window.Upgrade) 
					return window.Upgrade.startDownload();
				else
					console.info("未找到可用的组件！");
			}
		},
		
		Map : {
			show : function(longitude, latitude, address){
				if (window.Map) 
					return window.Map.show(longitude, latitude, address);
				else
					console.info("未找到可用的组件！");
			},
			
			getLocation : function(){
				if (window.Map && window.Map.getLocation) {
					if (window.Map.getLocation() == null) {
						//sd.dialog.showShort("无法获取您当前的位置");
						return null;
					}
					return JSON.parse(window.Map.getLocation());
				} else
					console.info("未找到可用的组件！");
			}
		},
		
		Phone : {
			call : function(phoneNumber){
				if (window.Phone) 
					return window.Phone.call(phoneNumber);
				else
					console.info("未找到可用的组件！");
			} 
		}
	};
	
	/**
	 * 通用页面正在加载提示
	 *
	 * 调用方式：(content不填则取默认值)
	 * sd.loading.show  显示遮罩层
	 * sd.loading.hide  关闭遮罩层
	 * sd.loading.show("loading.gif") 显示相对于当前网页传入地址的图片遮罩层
	 * @baseImageUrl 图片路径，为空则通过路径给则解析默认生成
	 * @content 加载提示信息
	 */
	sd.loading = {
		/**
		 * 显示加载层
		 * @param {Object} promptInfo
		 * @param {Object} baseImageUrl
		 */
	    show: function show(promptInfo, baseImageUrl){
	        var imageUrl;
	        
	        promptInfo = promptInfo == undefined ? "" : promptInfo;
	        if (baseImageUrl === undefined) {
				imageUrl = sd.genRelativePath("themes/sdui-gmu/default/img/loading.gif");
	        } else {
	            imageUrl = baseImageUrl;
	        }
	        $("body").append('<div id="loadingDiv" style="width:100%;height:100%;background:rgba(0,0,0,0.5);z-index:1000;position:absolute;left:0;top:0;">' +
	        					'<div style="position:absolute;left:25%;top:45%;width:50%;text-align:center;">' +
	        						'<img src="' + imageUrl + '" width="64" hight="64"><br/>' +
	        						'<span style="color:#FFF;">' + promptInfo + '</span>' +
	        					'</div>' +
	        				'</div>');
	        imageUrl = null;
	    },
	    hide: function hide(){
	        if ($("#loadingDiv") != undefined) 
	            $("#loadingDiv").remove();
	    }
	};
	
	/**
	 * 页面加载事件处理
	 * @param {Object} obj 可执行代码
	 */
	sd.page = {
		onload : function(obj) {
			eval(obj);
		},
		onbeforeunload : function(obj) {
			eval(obj);
		},
		onunload : function(obj) {
			eval(obj);
		}
	};
	
	/**
	 * 页面间跳转，使用url传递参数
	 * 参数获取方式：sd.request.getParameter(arg0)
	 */
	sd.request = {
	    params: {},
	    
	    analyzeParameters: function(){
	        var search = window.location.search;
	        var paramPairs = search.substring(1).match(new RegExp("[\&]?[^\?&]+=[^\?&]+", "g"));
	        if (paramPairs == null) 
	            return;
	        var paramPair = null;
	        for (var i = 0; i < paramPairs.length; i++) {
	            paramPair = paramPairs[i].replace("&", "").split("=");
	            this.params['' + paramPair[0]] = paramPair[1];
	        }
	    },
	    
	    getParameter: function(arg0){
	        return this.params['' + arg0] == undefined ? null : this.params['' + arg0];
	    }
	};
	
	/**
	 * 格式化时间，将毫秒值，转换成时长[hh'mm'ss]
	 * @param {Object} duration
	 */
	sd.formatDuration = function(duration){
		if (duration == null || duration == "" || duration == undefined) 
        return "";
	    var temp = "";
	    if ((duration / (1000 * 1000)) >= 1) {
	        temp += parseInt(duration / (1000 * 1000)) + "'" + parseInt(duration % (1000 * 1000) / 1000) + "\"";
	    }
	    else {
	        temp += parseInt(duration / 1000) + "\"";
	    }
	    return temp;
	};
	
	/**
	 * 对象属性复制
	 * @param {Object} source 源对象（为空将不复制）
	 * @param {Object} target 目标对象（为空将抛出异常）
	 */
	sd.copyProperties = function(source, target) {
		if (source == undefined || source == null)
			return;
		if (target == undefined || target == null)
			throw new Error("target object can't be null");
		for (var attr in source) {
			if (source[attr] != null && source[attr] != undefined)
				target[attr] = source[attr];
		}
	};
	
	/**
	 * 判断变量是否为空（null, 空字符串，undefined）
	 * @param {Object} _param
	 */
	sd.isBlank = function(_param) {
		if (_param == null || _param == undefined 
				|| _param.replace("\\s","") == "") {
			return true; 
		}
		return false;
	};
	
	/**
	 * 生成当前文件相对www目录目标文件的相对路径
	 * @param {Object} themesPath www目录下相对路径的的目标文件
	 */
	sd.genRelativePath = function(_path) {
		var relativePath = _path;
		var currentPath = window.location.pathname;
	    var pathes = currentPath.split("/");
	    
		var flag = false;
	    for (var i = 0; i < pathes.length - 1; i++) {
			flag = flag ? flag : pathes[i] == "www";
			if (!flag || pathes[i] == "www")
				continue;
	        relativePath = "../" + relativePath;
	    }
		return relativePath;
	};
	
	/**
	 * 支持在touch+iscroll滚动页面进行表单输入及按钮点击事件
	 */
	sd.allowFormsInIscroll = function(){
	    [].slice.call(document.querySelectorAll('input, select, button')).forEach(function(el){
	        el.addEventListener(('ontouchstart' in window) ? 'touchstart' : 'mousedown', function(e){
	            e.stopPropagation();
	        });
	    });
	};
	
	/**
	 * 初始化头部导航栏的宽度
	 */
	sd.initHeader = function () {
		var leftW = $(".ui-toolbar-header-left-box").width();
		var rightW = $(".ui-toolbar-header-right-box").width();
		var middleW = $(".ui-toolbar-header-middle-box").width();
		//var boxW = leftW > rightW ? leftW : rightW;
		//var boxW = ($(window).width() - middleW) / 2;
		var boxW = Math.round($(window).width() * 2 /7);
		$(".ui-toolbar-header-left-box").css("width", boxW);
		$(".ui-toolbar-header-right-box").css("width", boxW);
	};
	
	sd.checkUpdate = function() {
		dialog_confirm = gmu.Dialog({
			buttons: {
				'确定': function(){
					this.close();
					sd.native.Upgrade.startDownload();
				},
				'取消': function(){
					this.close();
				}
			},
			title:'<span>' + '版本更新' + '</span>',
			content:'检测到新的版本，是否更新？',
			autoOpen: false,
		    closeBtn: false,
		    mask: false,
			height: 150,
		    width: 300
		});
		
		var flag = sd.native.Upgrade.isUpgradeAvailable();
		if (flag){
			dialog_confirm.open();
		}
	};
})();




//页面加载完后的初始化事件
$(function(){

	sd.initHeader();
	
	sd.allowFormsInIscroll();
	
	sd.event.registerBackEvent();
});
