$(function(){
	 //初始化foot
	sd.ui.initFooter(5, 2);
	tourist.showMessageCount();
	 //初始化界面
	initCharacterInformation();
	
	//初始化详细界面
	initItemDetailPagePanel();
	
	// 注册一个生成图片src用的Helper
	Handlebars.registerHelper("genAttachImgSrc", function(value) {
		return tourist.genAttachImgUrl(value);
	});
	
	Handlebars.registerHelper("summaryTitleCustom", function(value) {
		if (this.content.summaryTitle == "")
			return "简介";
		return new Handlebars.SafeString(this.content.summaryTitle);
	});
	
	$(".temple-block").live("singleTap",function(){
		var itemId = $(this).attr("id");
		var itemType = $(this).attr("name");
		sessionStorage.setItem("item_id",itemId);
		if(itemType==2){
			sessionStorage.setItem("return_title",$('#character_title').html());
			window.location.href = "characteristics_list.html";
		}else{
			$(".btn-return-title").text("");
			getItemDetailMessage();
		}
	});
	
	$('.return').hide();
	$('.return-history').show();
	
	$(".return-history").live("singleTap",function(){
    	window.location.href = "../home.html";
    });
	
	$(".btn-close").live("singleTap",function(){
    	hideImg();
    });
    
    $(".phone").live("singleTap",function(){
    	var phoneNumber = $(this).attr("name");
    	sd.native.Phone.call(phoneNumber);
    });
    
    $(".location").live("singleTap",function(){
    	var address = $(this).parent().parent().children(".address_detail").children("#address").html();
    	sd.native.Map.show($(this).attr("latitude"),$(this).attr("longitude"),address);
    });
    
    if (sessionStorage.getItem("isRelateTo") != null) {
    	getItemDetailMessage();
    	sessionStorage.removeItem("isRelateTo");
    }
});

/**
 *初始化界面 
 */
var mainTitle = "";
function initCharacterInformation(){	
	//1、获取当前地区特色的ID参数
	var param = getCharacterParam();
	
	//2、请求后台，获取当前地区特色的信息
	var url = baseUrl + "appinter/scenicfeaturejsonp/listFeatureItem.do?"+param+"&callback=?";
	$.ajaxJSONP({
		type : "GET",
		url : url,
		beforeSend : function() {
			sd.loading.show();
		},
		success : function(data) {
			if(data && data.result==1){
				$("#character_title").text(subString(data.vo.feature.featureName,8,true));
				mainTitle = data.vo.feature.featureName;
				$("#character_title").attr("name",data.vo.feature.featureId);
				createCharacterLayout(data);
			}
		},
		error : function(e) {
			sd.dialog.showShort("连接超时！");
		},
		complete : function() {
			sd.loading.hide();
		}
	});
}

function getCharacterParam(){
	var characterId = sessionStorage.getItem("character_id");
	if (characterId != null) {
		var param = "featureId="+characterId;
		return param;
	} else {
		return "featureId=4028818b4b71ada0014b71b20d910002";
	}
}

function createCharacterLayout(data){
	var source = $("#character-template").html();
	var template = Handlebars.compile(source);
	var html = template(data);
	$(".ui-refresh").append(html);
	setTimeout("refreshLayout()", 1000);
}

function refreshLayout() {
	var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height();
	var refreshDom = $('.ui-refresh').css("width", "100%").css("height", wrapperHeight);
	refreshDom.refresh({iScrollOpts : {
			bounce : false
		}});
	$(refreshDom).css("height", "auto");
	$(refreshDom).css("overflow", "hidden");
};

function refreshPanelLayout() {
	var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height();
	var refreshDom = $('#item-panel-refresh').css("width", "100%").css("height", wrapperHeight);
	refreshDom.refresh({iScrollOpts : {
			bounce : false
		}}
	);
	$(refreshDom).css("height", "auto");
	$(refreshDom).css("overflow", "hidden");
};

function initItemDetailPagePanel(){
	var returnTitle = $('#character_title').html();
    var refreshDom = $("#item-panel-refresh").css("height", $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height());

    refreshDom.refresh({
        iScrollOpts : {
            bounce : false
        }
    });

    $('#item-panel').panel({
        contentWrap : $('#character_content'),
        swipeClose : true,
        dismissible : true,
        beforeopen : function() {
            $(".return").live("singleTap",function(){
            	$('#item-panel').panel('close');
            });
             $(".scene").live("singleTap",function(){
             	var relatedSceneId = $(this).children("img").attr("id");
             	var relatedScene = $(this).children("span").html();
            	sessionStorage.setItem("scene_id",relatedSceneId);
            	if (relatedSceneId != "") {
	            	var scenicAreaInfo = {
			            scenicAreaid : relatedSceneId,
			            scenicAreaName : relatedScene
			        };
	        		sessionStorage.setItem("scenicAreaInfo", JSON.stringify(scenicAreaInfo));
	        		sessionStorage.setItem("isRelateTo", true);
	            	window.location.href = sd.genRelativePath("web/spot/spot_detail.html");
            	}
            });
            $(".picture").live("singleTap",function(){
            	showImg($(this).children("img").attr("name"));
            });
            /*$(".goToScene").live("singleTap",function(){
            	sessionStorage.setItem("scene_id",$(this).attr("id"));
            });*/
            $(".goToPicture").live("singleTap",function(){
            	showImg($(this).attr("name"));
            });
        },
        open : function() {
            // 刷新iscroll
            refreshDom.refresh('this')._options.iScroll.refresh();
            $('.return-history').hide();
            $('.return').show();
        },
        beforeclose : function() {
    		refreshDom.find("#item-detail-content").html(null);
    		$("#character_title").text(subString(mainTitle,8,true));
    		$(".btn-return-title").text("主页");
    		$('.return').hide();
			$('.return-history').show();
        },
        close : function() {
        	$('.return').hide();
            $('.return-history').show();  
        }
    });
}

function getItemDetailMessage(){
	var itemId = sessionStorage.getItem("item_id");
	$.ajaxJSONP({
        type : "GET",
        url : baseUrl + "appinter/scenicfeaturejsonp/listCategoryItem.do?featureItemId="+itemId+"&callback=?",
        beforeSend : function() {
            sd.loading.show();
        },
        success : function(data) {
        	if(data && data.result==1){
        		sd.loading.hide();
        		$("#character_title").text(subString(data.vo.featureItem.featureItemName,8,true));
        		$("#character_title").attr("name",data.vo.featureItem.featureItemId);
            	createItemDetailMessage(data.vo);
        	}
        },
        error : function(e) {
            sd.loading.hide();
            sd.dialog.showShort("连接超时！");
        },
        complete : function(data) {
            sd.loading.hide();
            //sessionStorage.removeItem("item_id");
        }
    });
}

function createItemDetailMessage(data){
	var source = $("#item-detail-template").html();
	var template = Handlebars.compile(source);
	var html = template(data);
	$("#item-panel-refresh").html(null);
	$("#item-panel-refresh").append(html);
	setTimeout("refreshPanelLayout()", 1000);
	$('#item-panel').panel('open', 'push', 'right');
}

function showImg(baseImageUrl){
	if ($("#routeDiv") != undefined) {
    	$("#routeDiv").remove();
    }
	var imgUrl = tourist.genAttachImgUrl(baseImageUrl);
    $("#item-panel").append('<div id="routeDiv" style="width:100%;height:100%;background:rgba(255,255,255,1);z-index:1000;position:absolute;left:0;top:0;">' +
    					'<div style="position:absolute;text-align:center;">' +
    						'<img src="' + imgUrl + '" width="100%" height="auto">' +
    					'</div>' +
    				'</div>');
    sessionStorage.setItem("character_title",$('#character_title').html());
    $('.btn-return').hide();
    $('.btn-return-title').hide();
    $('.btn-close').show();
    $('#character_title').text("路线");
}

function hideImg(){
    if ($("#routeDiv") != undefined) {
    	$("#routeDiv").remove();
        $('.btn-return').show();
	    $('.btn-return-title').show();
	    $('.btn-close').hide();
        $('#character_title').text(sessionStorage.getItem("character_title"));
        sessionStorage.removeItem("character_title");
     }
}

function subString(str, len, hasDot) 
{ 
    var newLength = 0; 
    var newStr = ""; 
    var chineseRegex = /[^\x00-\xff]/g; 
    var singleChar = ""; 
    if(str!=null){
    	var strLength = str.replace(chineseRegex,"**").length; 
	    if(strLength==(len+2)){
	    	return str;
	    }
	    for(var i = 0;i < strLength;i++) 
	    { 
	        singleChar = str.charAt(i).toString(); 
	        if(singleChar.match(chineseRegex) != null) 
	        { 
	            newLength += 2; 
	        }     
	        else 
	        { 
	            newLength++; 
	        } 
	        if(newLength > len) 
	        { 
	            break; 
	        } 
	        newStr += singleChar; 
	    } 
	     
	    if(hasDot && strLength > len) 
	    { 
	        newStr += ".."; 
	    } 
	    return newStr; 
    }else{
    	return str;
    }
} 

 //如果因为网络或图片的原因发生异常，则显示该图片 
var errorRefresh = function(v){
	$("#upload_quiz_img").attr("src","../../img/nanjing.png");
};