$(function(){
	tourist.showMessageCount();
	var returnTitle = sessionStorage.getItem("return_title");
	$(".btn-return-title").text(subString(returnTitle,4,true));
	sessionStorage.removeItem("return_title");

	 //初始化foot
	sd.ui.initFooter(5, 2);
	
	 //初始化界面
	initItemMessage();
	
	initItemDetailPagePanel();
	
	$(".item-block").live("singleTap",function(){
		var itemDetailId = $(this).attr("id");
		$(".btn-return-title").text("");
		sessionStorage.setItem("returnTitle",$("#character_title").html());
		getItemDetailMessage(itemDetailId);
	});
	
	$(".btn-close").live("singleTap",function(){
    	hideImg();
    });
    
    $('.return').hide();
	$('.return-history').show();
	
	$(".return-history").live("singleTap",function(){
    	window.history.go(-1);
    });
    
    // 注册一个生成图片src用的Helper
	Handlebars.registerHelper("genAttachImgSrc", function(value) {
		return tourist.genAttachImgUrl(value);
	});
	
	$(".phone").live("singleTap",function(){
    	var phoneNumber = $(this).attr("name");
    	sd.native.Phone.call(phoneNumber);
    });
    
    $(".location").live("singleTap",function(){
    	var address = $(this).parent().parent().children(".address_detail").children("#address").html();
    	sd.native.Map.show($(this).attr("latitude"),$(this).attr("longitude"),address);
    });
});

/**
 *初始化界面 
 */
function initItemMessage(){
	//1、获取当前地区特色的ID参数
	var param = getItemParam();
	
	//2、请求后台，获取当前地区特色的信息
	var url = baseUrl + "appinter/scenicfeaturejsonp/listCategoryItem.do?"+param+"&callback=?";
	$.ajaxJSONP({
		type : "GET",
		url : url,
		beforeSend : function() {
			sd.loading.show();
		},
		success : function(data) {
			if(data && data.result==1){
				$("#character_title").text(subString(data.vo.featureItem.featureItemName,12,true));
        		$("#character_title").attr("name",data.vo.featureItem.featureItemId);
				createItemLayout(data);
			}
		},
		error : function(e) {
			sd.dialog.showShort("连接超时！");
		},
		complete : function() {
			sd.loading.hide();
		}
	});
}

function getItemParam(){
	var itemId = sessionStorage.getItem("item_id");
	if (itemId != null) {
		var param = "featureItemId="+itemId;
		sessionStorage.removeItem("item_id");
		return param;
	} else {
		return "";
	}
}

function createItemLayout(data){
	var source = $("#item-template").html();
	var template = Handlebars.compile(source);
	var html = template(data);
	$(".ui-refresh").append(html);
	setTimeout("refreshLayout()", 1000);
}

function refreshLayout() {
	var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height();
	var refreshDom = $('.ui-refresh').css("width", "100%").css("height", wrapperHeight);
	refreshDom.refresh({iScrollOpts : {
			bounce : false
		}});
	$(refreshDom).css("height", "auto");
	$(refreshDom).css("overflow", "hidden");
};

function getItemDetailMessage(itemDetailId){
	$.ajaxJSONP({
                type : "GET",
                url : baseUrl + "appinter/scenicfeaturejsonp/listDetail.do?featureCategoryItemId="+itemDetailId+"&callback=?",
                beforeSend : function() {
                    sd.loading.show();
                },
                success : function(data) {
                    if(data && data.result==1){
		        		sd.loading.hide();
		        		$("#character_title").text(subString(data.vo.content.featureCategoryItemName,12,true));
		        		$("#character_title").attr("name",data.vo.content.featureCategoryItemId);
		            	createItemDetailMessage(data);
		        	}
                },
                error : function(e) {
                    sd.loading.hide();
                    sd.dialog.showShort("连接超时！");
                },
                complete : function(data) {
                    sd.loading.hide();
                    sessionStorage.removeItem("item_id");
                }
            });
}

function refreshPanelLayout() {
	var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height();
	var refreshDom = $('#item-panel-refresh').css("width", "100%").css("height", wrapperHeight);
	refreshDom.refresh({iScrollOpts : {
			bounce : false
		}}
	);
	$(refreshDom).css("height", "auto");
	$(refreshDom).css("overflow", "hidden");
};

function initItemDetailPagePanel(){
	var returnTitle = $('#character_title').html();
	var returnTitle2 = $('.btn-return-title').html();
    var refreshDom = $("#item-panel-refresh").css("height", $(window).height() - $('.ui-toolbar-header').height()-$('.ui-toolbar-footer').height());

    refreshDom.refresh({
        iScrollOpts : {
            bounce : false
        }
    });

    $('#item-panel').panel({
        contentWrap : $('.ui-content'),
        swipeClose : true,
        dismissible : true,
        beforeopen : function() {
            $(".return").live("singleTap",function(){
            	$('#item-panel').panel('close');
            	$('#character_title').text(sessionStorage.getItem("returnTitle"));
            });
            $(".scene").live("singleTap",function(){
            	sessionStorage.setItem("scene_id",$(this).children("img").attr("id"));
            	window.location.href = "../";
            });
            $(".picture").live("singleTap",function(){
            	showImg($(this).children("img").attr("name"));
            });
            $(".goToScene").live("singleTap",function(){
            	sessionStorage.setItem("scene_id",$(this).attr("id"));
            	window.location.href = "../";
            });
            $(".goToPicture").live("singleTap",function(){
            	showImg($(this).attr("name"));
            });
        },
        open : function() {
            // 刷新iscroll
            refreshDom.refresh('this')._options.iScroll.refresh();
            $('.return-history').hide();
            $('.return').show();
        },
        beforeclose : function() {
    		refreshDom.find("#item-detail-content").html(null);
    		$(".btn-return-title").text(returnTitle2);
    		$('#character_title').text(returnTitle);
        },
        close : function(){
        	$('.return').hide();
            $('.return-history').show();  
        }
    });
}

function createItemDetailMessage(data){
	var source = $("#item-detail-template").html();
	var template = Handlebars.compile(source);
	var html = template(data);
	$("#item-panel-refresh").html(null);
	$("#item-panel-refresh").append(html);
	setTimeout("refreshPanelLayout()", 1000);
	$('#item-panel').panel('open', 'push', 'right');
}

function showImg(baseImageUrl){
    var imgUrl = tourist.genAttachImgUrl(baseImageUrl);
    $("#item-panel").append('<div id="routeDiv" style="width:100%;height:100%;background:rgba(255,255,255,1);z-index:1000;position:absolute;left:0;top:0;">' +
    					'<div style="width:100%;position:absolute;text-align:center;">' +
    						'<img src="' + imgUrl + '" width="100%" height="auto">' +
    					'</div>' +
    				'</div>');
    sessionStorage.setItem("character_title",$('#character_title').html());
    $('.btn-return').hide();
    $('.btn-return-title').hide();
    $('.btn-close').show();
    $('#character_title').text("路线");
}

function hideImg(){
    if ($("#routeDiv") != undefined) {
    	$("#routeDiv").remove();
        $('.return').show();
	    $('.btn-close').hide();
        $('#character_title').text(sessionStorage.getItem("character_title"));
        sessionStorage.removeItem("character_title");
     }
}

function subString(str, len, hasDot) 
{ 
    var newLength = 0; 
    var newStr = ""; 
    var chineseRegex = /[^\x00-\xff]/g; 
    var singleChar = ""; 
    if(str!=null){
    	var strLength = str.replace(chineseRegex,"**").length; 
	    if(strLength==(len+2)){
	    	return str;
	    }
	    for(var i = 0;i < strLength;i++) 
	    { 
	        singleChar = str.charAt(i).toString(); 
	        if(singleChar.match(chineseRegex) != null) 
	        { 
	            newLength += 2; 
	        }     
	        else 
	        { 
	            newLength++; 
	        } 
	        if(newLength > len) 
	        { 
	            break; 
	        } 
	        newStr += singleChar; 
	    } 
	     
	    if(hasDot && strLength > len) 
	    { 
	        newStr += ".."; 
	    } 
	    return newStr; 
    }else{
    	return str;
    }
} 

//如果因为网络或图片的原因发生异常，则显示该图片 
function errorRefresh(v){
	$("#upload_quiz_img").attr("src","../../img/nanjing.png");
};