/**
 * 应用中页面公用的js文件，包与具体业务相关的变量、方法等。
 * baseUrl	服务器访问根路径
 * 其他页面都需引入此js文件
 */
//var baseUrl = "http://202.10.76.114:8080/tourist-server/";
//var baseUrl = "http://27.54.226.100:8088/tourist-helper/";
var baseUrl = "http://prj.yhiker.com/";

(function() {
    window['tourist'] = {};
    //分页大小
    tourist.pageSize = 5;
    //是否自动播放
    tourist.autoPlay = true;

    tourist.appuser = {
        id : null,
        name : null,
        userName : null,
        headPhotoId : null,
        orgId : null,

        init : function() {
            var userInfo = localStorage.getItem("appuser");
            if (userInfo != null) {
                var userJson = JSON.parse(userInfo);
                this.id = userJson.id != undefined ? userJson.id : null;
                this.name = userJson.name != undefined ? userJson.name : null;
                this.orgId = userJson.orgId != undefined ? userJson.orgId : null;
                this.headPhotoId = userJson.headPhotoId != undefined ? userJson.headPhotoId : null;
                this.userName = userJson.userName != undefined ? userJson.userName : null;
            }
        },

        saveUser : function(userJson) {
            var appUser = {
                id : userJson.userId,
                headPhotoId : userJson.userAttach,
                name : userJson.name,
                userName : userJson.userName
            };
            localStorage.setItem("appuser", JSON.stringify(appUser));
        },

        removeUser : function() {
            localStorage.removeItem("appuser");
            localStorage.removeItem("bufferHeadPhoto");
        }
    };

    tourist.isLogin = function() {
        if (tourist.appuser.id != null)
            return true;
        return false;
    };

    tourist.logout = function() {
        if (tourist.isLogin()) {
            localStorage.removeItem("appuser");
            localStorage.removeItem("bufferHeadPhoto");
        }
        return true;
    };

    tourist.showMessageCount = function() {
        if (localStorage.getItem("message_count") && localStorage.getItem("message_count") > 0) {
            $(".message_number").text(localStorage.getItem("message_count"));
            $(".message_count").show();
        }
    };

    tourist.hideMessageCount = function() {
        $(".message_count").hide();
    };

    tourist.logonAuth = function() {
        if (!tourist.isLogin()) {
            window.location.href = "../login/login.html";
        }
    };

    tourist.genAttachImgUrl = function(attachId) {
        // 存在attachId 返回指定图像地址 否则返回用户头像地址
        if (attachId) {
            return baseUrl + "/appinter/appattachjsonp/downloadImage.do?needThumbnail=true&type=1&attachId=" + attachId;
        } else {
            return "../img/nanjing.png";
        }

    };

    tourist.genBGMUrl = function(attachId) {
        if (attachId)
            return "http://sc1.111ttt.com/2015/1/03/09/96092317024.mp3";
    };

    var jsplayer = function() {
        this.duration = 0;
        this.percent = 0;
        this.interval = null;
        this.lastPosition = 0;
        this.isComplete = true;

        this.options = {
            scenicAreaId : null,
            scenicSpotId : null,
            downlaodUrl : null,
            onStartPlay : null,
            onReplay : null,
            onPause : null,
            onUpdateProgress : null,
            onComplete : null,
            onLoading : null,
            onLoadError : null,
            onLoadComplete : null,
        };

        this.init = function(options) {
            if (options == undefined)
                return;

            this.options.scenicAreaId = options.scenicAreaId;
            this.options.scenicSpotId = options.scenicSpotId;
            this.options.downloadUrl = options.downloadUrl;

            this.options.onStartPlay = options.onStartPlay;
            this.options.onReplay = options.onReplay;
            this.options.onPause = options.onPause;
            this.options.onUpdateProgress = options.onUpdateProgress;
            this.options.onComplete = options.onComplete;
            this.options.onLoading = options.onLoading;
            this.options.onLoadError = options.onLoadError;
            this.options.onLoadComplete = options.onLoadComplete;

            if (window.ScenicAudio.isPlaying() == true && typeof (this.options.onReplay) == "function") {
                this.duration = window.ScenicAudio.totalDuration();
                this.options.onReplay.call();
            }
        };

		var scenicAreaInfo = JSON.parse(sessionStorage.getItem("scenicAreaInfo"));
        this.play = function() {
        	var isPlayingScenicSpotid = sessionStorage.getItem("isPlayingScenicSpotid");

			if(isPlayingScenicSpotid != null && this.options.scenicSpotId != isPlayingScenicSpotid){
                clearInterval(this.interval);
    		 	this.lastPosition = 0;
    		 	this.duration = window.ScenicAudio.playAudio(this.options.scenicAreaId, this.options.scenicSpotId, this.options.downloadUrl);
        		console.info("lastPosition:"+this.lastPosition+"-----currentPosition:"+window.ScenicAudio.currentPosition());
    		 	console.info(" 进入播放新的音频文件 output the duration:"+this.duration);
                if (this.duration > 0) {
                    isComplete = false;
                    sessionStorage.setItem("isPlayingScenicSpotid", this.options.scenicSpotId);
                    this.interval = setInterval("tourist.jsplayer.updateProgress()", 500);
                    console.info("设置新的Id进入session中，并且已经在播放了");
                    
                    if ( typeof (this.options.onStartPlay) == "function"){
                        this.options.onStartPlay.call();
                    }else{
                    	console.info("没有进入onstartplay功能，没有回调 ");
                    }
                } else {
                	console.info(" 音频没有时间长度:"+this.options.scenicSpotId);
                    sessionStorage.setItem("isPlayingScenicSpotid", this.options.scenicSpotId);

                }
        	}else{
	        	console.info("进入同一个音频文件，并且得到nowId："+isPlayingScenicSpotid );
	        	//判断当前播放组建是否正在处于播放状态，是则暂停播放
	            if (window.ScenicAudio.isPlaying() == true ) {
	                window.ScenicAudio.pausePlay();
	                clearInterval(this.interval);
	//              sessionStorage.removeItem("isPlayingScenicSpotid");
	                if ( typeof (this.options.onPause) == "function")
	                    this.options.onPause.call();
	            } else {
	            	//如果lastPosition(最后一次播放的位置)大于0，则表示上次的播放未结束，则恢复播放；否则，表示从头开始播放
	                if (this.lastPosition > 0) {
        	console.info("lastPosition1:"+this.lastPosition+"-----currentPosition:"+window.ScenicAudio.currentPosition());
	                    window.ScenicAudio.replay();
	                    this.interval = setInterval("tourist.jsplayer.updateProgress()", 500);
	                    sessionStorage.setItem("isPlayingScenicSpotid", this.options.scenicSpotId);
	                    if ( typeof (this.options.onReplay) == "function")
	                        this.options.onReplay.call();
	                } else {
	                    this.duration = window.ScenicAudio.playAudio(this.options.scenicAreaId, this.options.scenicSpotId, this.options.downloadUrl);
        	console.info("lastPosition3:"+this.lastPosition+"-----currentPosition:"+window.ScenicAudio.currentPosition());
	                    if (this.duration > 0) {
	                        isComplete = false;
	                        sessionStorage.setItem("isPlayingScenicSpotid", this.options.scenicSpotId);
	                        this.interval = setInterval("tourist.jsplayer.updateProgress()", 500);
	                        if ( typeof (this.options.onStartPlay) == "function")
	                            this.options.onStartPlay.call();
	                    } else {
	
	                    }
	                }
	            }
            }
        };

        this.updateProgress = function() {
            var currentPostition = window.ScenicAudio.currentPosition();
            
            console.info("currenPosition:"+currentPostition);
            if (this.lastPosition >= currentPostition) {
                this.lastPosition = 0;
                clearInterval(this.interval);
                isComplete = true;
                if ( typeof (this.options.onComplete) == "function")
                    this.options.onComplete.call();

                this.hidePlayStatus();
                sessionStorage.removeItem("isPlayingScenicSpotid");
                return;
            }

            this.percent = currentPostition / this.duration;
            this.lastPosition = currentPostition;
            if ( typeof (this.options.onUpdateProgress) == "function")
                this.options.onUpdateProgress.call();
        };

        this.onLoading = function() {
            if ( typeof (this.options.onLoading) == "function")
                this.options.onLoading.call();
        };

        this.onLoadError = function() {
            if ( typeof (this.options.onLoadError) == "function")
                this.options.onLoadError.call();
        };

        this.onLoadComplete = function() {
            if ( typeof (this.options.onLoadComplete) == "function") {
                this.play();
            }
        };

        this.keepPlay = function() {
            if ( typeof (this.options.onUpdateProgress) == "function")
                return;
            if (window.ScenicAudio)
                if (window.ScenicAudio.isPlaying()) {
                	var isPlayingScenicSpotid = sessionStorage.getItem("isPlayingScenicSpotid");
        			var scenicSpotInfo = JSON.parse(sessionStorage.getItem("scenicSpotInfo"));
        			var currentScenicSpotid = scenicSpotInfo.scenicSpotid;
        			if (currentScenicSpotid != isPlayingScenicSpotid) {
        				window.ScenicAudio.stopPlay();
        				return;
        			}
                
                    this.interval = setInterval("tourist.jsplayer.updateProgress()", 500);
                }
        };

        this.showPlayStatus = function() {
            $("#status_playing").show();
            $("#status_playing").live("singleTap", function() {
            	window.sessionStorage.setItem("navigateIndex", 0);
                window.location.href = sd.genRelativePath("web/spot/spot_view.html");
            });
        };

        this.hidePlayStatus = function() {
            $("#status_playing").hide();
        };
    };

    tourist.jsplayer = new jsplayer();
    tourist.jsplayer.keepPlay();
})();

$(function() {
    if (window.ScenicAudio) {
        if (window.ScenicAudio.isPlaying() == true && typeof (tourist.jsplayer.options.onReplay) != "function") {
            tourist.jsplayer.showPlayStatus();
        }
    }
    
    $("footer").find("ul li").on("touchstart",function(){
		sessionStorage.removeItem("returnFromSpotView");
	});
});

//从本地存储加载用户信息
tourist.appuser.init();
