function getElem (id) {
  return document.getElementById(id);
}

function trimPX (_px) {
  if(_px==null || _px=="")
    return 0;
  return parseInt(_px.substr(0, _px.lastIndexOf("px")));
}

function hitInRect (hitX, hitY, rcLeft, rcTop, rcWidth, rcHeight) {
  return (hitX>=rcLeft && hitX<rcLeft+rcWidth && hitY>=rcTop && hitY<rcTop+rcHeight);
}

function mapVisualDiv () {
  return getElem("mapVisualDiv");
}

function mapContainer () {
  return getElem("mapContainer");
}

var dragging = false;
var startTop = 0; // top is a Key Word in Chrome and Opera
var startLeft = 0;
var dragPosY = 0;
var dragPosX = 0;

window.addEventListener("load", initPage, false);

function initPage () {
  	$("#mapVisualDiv").on("touchstart", // start moving image
	    function (event) {
	      	startTop = trimPX(mapContainer().style.top);
	    	startLeft = trimPX(mapContainer().style.left);
	      	var width = $("#mapContainer").width();
	      	var height = $("#mapContainer").height();
	//alert(event.clientX);alert(3);
	//alert(event.changedTouches[0].clientX);
	//alert(event.clientY);
	//alert(startLeft);alert(startTop);alert(width);alert(height);
	      	if (hitInRect(event.changedTouches[0].clientX, event.changedTouches[0].clientY, startLeft, startTop, width, height)) {
		        dragging = true;
		        dragPosX = event.changedTouches[0].clientX;
		        dragPosY = event.changedTouches[0].clientY;
		        event.preventDefault(); // disable default behavior of browser
	      	}
	    },
    	false
  	);
/**
 * 拖动事件,依据图片的大小,拖动依据在屏幕范围内
 */
  	$("#mapVisualDiv").on("touchmove", // moving image
    	function (event) {
      		if (dragging){
		        mapContainer().style.cursor="pointer";
		        mapContainer().style.top = parseInt(startTop)+(event.changedTouches[0].clientY - dragPosY) + "px";
		        mapContainer().style.left = parseInt(startLeft)+(event.changedTouches[0].clientX - dragPosX) + "px";
		        //获取显示图片的宽高，图片与父级div重合
		        var imgWidth = trimPX(mapContainer().style.width);
		        var imgHeight = trimPX(mapContainer().style.height);
		        
		        //获取图片父级的top left值
				var marginLeft = trimPX(mapContainer().style.left);
				var marginTop = trimPX(mapContainer().style.top);
				//获取设备可显示区域的宽高
				var visualDivWidth = trimPX(mapVisualDiv().style.width);
				var visualDivHeight = trimPX(mapVisualDiv().style.height);
				//判断图片与显示窗口的关系,小图不可移动，大图可移动
				//imgWidth < visualDivWidth 判断图片与窗口的大小
				if(marginLeft >= 0 || (imgWidth < visualDivWidth)){
					mapContainer().style.left = "0px";
				}
				if(marginTop >= 0 || (imgHeight < visualDivHeight)){
					mapContainer().style.top = "0px";
				}
				//图片与窗口边距
				var rMargin = trimPX(mapContainer().style.width) - visualDivWidth;
				if(Math.abs(trimPX(mapContainer().style.left)) > Math.abs(rMargin)){
					mapContainer().style.left = -rMargin+"px";
				}
				//图片与窗口边距
				var bMargin = trimPX(mapContainer().style.height) - visualDivHeight;
				if(Math.abs(trimPX(mapContainer().style.top)) > Math.abs(bMargin)){
					mapContainer().style.top = -bMargin+"px";
				}
      		}
      		//多点触摸事件，如果是放大则更换图片，如果是搜索，则缩小
	    	event.preventDefault();
    	},
    	false
  	);

  	$("#mapVisualDiv").on("touchend", // stop moving image
	    function (event) {
	      	dragging = false;
	      	mapContainer().style.cursor="default";
	      	event.preventDefault();
	      	event.stopPropagation();
	    },
	    false
  	);
}