var spotObj = ["elementHeight","elementWidth","latitude","longitude"
	,"spotAudio","spotId","spotName"]
//控件与点击位置偏移量
var imgOffsetX = 80;
var imgOffsetY = 50;

//自动播放按钮的默认播放状态为零
var isAutoPlay = true;
//圆的半径
var r = 40;
/**
 * 判断是否存在圆的范围之内
 * @param {Object} objC 每个景点的中心
 * @param {Object} point 当前的点击位置或者是定位的位置
 */
function isInCircle(point){
	for(var i=0;i<origin.length;i++){
		var objC = origin[i];
		var getR = Math.pow((point.x-objC.elementWidth),2)+Math.pow((point.y-objC.elementHeight),2);
		if(getR < Math.pow(r*rateXY,2)){
			return objC;
		}
	}
	return null;
}
/**
 * 播放前进行右上角点击事件处理，跳入播放音频界面时传递参数
 * @param {Object} obj 选中当前播放事件
 */
function beforePlaySpotAudio(obj){
	playSpotAudio(obj.spotId,obj.spotAudio);
	//点击右上角按钮会跳转页面并继续播放
	var scenicSpotInfo = {
        scenicSpotName : obj.spotName,
        scenicSpotid : obj.spotId
    };
    sessionStorage.setItem("scenicSpotInfo", JSON.stringify(scenicSpotInfo));
}
function setObjToSpotObj(obj){
	spotObj.elementWidth = obj.elementWidth;
	spotObj.elementHeight = obj.elementHeight;
	spotObj.latitude = obj.latitude;
	spotObj.longitude = obj.longitude;
	spotObj.spotAudio = obj.spotAudio;
	spotObj.spotId = obj.spotId;
	spotObj.spotName = obj.spotName;
}

/**
 * 自动播放或点击时弹出控件提示
 * @param {Object} point  当前像素点，或者是gis转换为图片的定位点
 * @param {boolean} isPlayOrShow  区分是否弹出控件或自动播放 true为自动播放 false为点击
 */
function autoPlayOrShowControl(point , isPlayOrShow){
	var obj = isInCircle(point);
//	像素点在景点范围内的操作
	if(obj!=null){
		//同一个景点时,只保持当前播放,解决景点范围内不停播放,可循环播放；
		//解决判断是否当前音频播放，则改变播放图片的状态
		var isPlayingScenicSpotid = sessionStorage.getItem("isPlayingScenicSpotid");
		if(isPlayOrShow){//自动定位播放事件操作
			if(isAutoPlay){//按钮默认自动播放
				if(!window.ScenicAudio.isPlaying()){//音频处于非播放状态操作
					//自动定位到获取的对象进行存储成spotObj
					setObjToSpotObj(obj);
					if(obj.spotId != isPlayingScenicSpotid){
						beforePlaySpotAudio(spotObj);
						//控件显示
						$("#playBg").css("left",(obj.elementWidth - imgOffsetX)+"px").css("top",(obj.elementHeight - imgOffsetY)+"px").show();
						//设置景点的名字
						$("#player_spotName").html(obj.spotName);
					}
				}
//				break;
			}else{//不自动播放时,无操作
//				break;
			}
		}else{//点击事件时的操作
			//控件显示
			$("#playBg").css("left",(obj.elementWidth - imgOffsetX)+"px").css("top",(obj.elementHeight - imgOffsetY)+"px").show();
			//解决判断是否当前音频播放，则改变播放图片的状态
			if(obj.spotId != isPlayingScenicSpotid){
				$("#playerButton").attr("src", "img/button_play.png");
			}else {
				if(window.ScenicAudio.isPlaying()){
					$("#playerButton").attr("src", "img/button_pause.png");
				}else{
					$("#playerButton").attr("src", "img/button_play.png");
				}
			}
			//点击到获取的对象进行存储成spotObj
			setObjToSpotObj(obj);
			//设置景点的名字
			$("#player_spotName").html(obj.spotName);
		}
	}else{//像素点不在景点范围内的操作
		$("#playBg").hide();
	}
}

/**
 * 设置触摸时播放控件显示
 */
function setVideoPosition(){
	$("#mapContainer").on("touchstart",function(event){
		//触摸屏幕的坐标
		var tapX = event.changedTouches[0].clientX;
		var tapY = event.changedTouches[0].clientY;
		//控件显示
		
		//鼠标的位置，此时的位置是在图片上的相对位置，不相对于整个屏幕
		var mouseX = tapX;
		var mouseY = event.changedTouches[0].clientY - $(".ui-toolbar-header").height() - $(".ui-tabs-nav").height();
		
		//图片的上边距与左距
		var offset = $("#mapContainer").offset();
		var imgLeft = offset.left;
		var imgTop = offset.top - $(".ui-toolbar-header").height() - $(".ui-tabs-nav").height();
		
		//触碰到图片的像素
		var tapImgX = tapX - imgLeft;
		var tapImgY = mouseY - imgTop;
		console.info("x:"+tapImgX+"--Y:"+tapImgY)

		//获取到当前图片的位置
		var point = {"x":tapImgX,"y":tapImgY};
		console.info("pointX:"+point.x+"---pointY:"+point.y)
		//false :判断自动进入该范围点击或点击 true为定位监控，false为点击
		autoPlayOrShowControl(point , false);
		//自行定位取消
		sessionStorage.setItem("autoMove",true);
	});
}
/**
 * 关闭与定位控件等各种图标事件,除了放大缩小
 * event.stopPropagation(); 阻止冒泡事件
 * 其他事件,看注释及自悟
 */
function initDetailPlayer(){
	/**
	 * 定位图片事件,可省略
	 */
	$("#spotPosition").on("touchstart", function(){
		$("#playBg").toggle();
//		event.stopPropagation();
	});
	/**
	 * 跳转到音频播放界面spotView
	 */
	$("#turnToView").on("touchstart",function(event){
		event.stopPropagation();
        var scenicSpotInfo = {
            scenicSpotName : spotObj.spotName,
      		scenicSpotid : spotObj.spotId
        };
        sessionStorage.setItem("scenicSpotInfo", JSON.stringify(scenicSpotInfo));
        sessionStorage.setItem("returnToMapView", true);
        window.location.href = "spot_view.html";
	});
	/**
	 * 播放按钮
	 */
	$("#playerButton").on("touchstart", function(event){
		event.stopPropagation();
		beforePlaySpotAudio(spotObj);
	});
	/**
	 * 自动播放音频按钮
	 */
	$(".isAutoPlay").on("touchstart",function(){
		if(debug)initMap();
		event.stopPropagation();
		if(isAutoPlay){
			isAutoPlay = false;
			$(".isAutoPlay").addClass("isAutoPlayOpacity");
			$(".isAutoPlay").attr("src","img/isAutoPlayOpacity_false.png");
			sd.dialog.showShort("关闭自动播放音频");
		}else{
			isAutoPlay = true;
			$(".isAutoPlay").removeClass("isAutoPlayOpacity");
			$(".isAutoPlay").attr("src","img/isAutoPlayOpacity_true.png");
			sd.dialog.showShort("开启自动播放音频");
		}
	});
	/**
	 * 自动切换路线图按钮
	 */
	$(".showItineraryRate").on("touchstart",function(){
        sd.loading.show("正在搬图,请稍后......");
		event.stopPropagation();
        
   	 	var flag = sessionStorage.getItem("itineraryFlag");
		var imgUrl = null;
		if(flag == null){
			sessionStorage.setItem("itineraryFlag",true);
			$(".showItineraryRate").addClass("imgOpacity");
			imgUrl = mapAndItineraryObj.itineraryAttach;
		}else{
			sessionStorage.removeItem("itineraryFlag");
			$(".showItineraryRate").removeClass("imgOpacity");
			imgUrl = mapAndItineraryObj.mapAttach;
		}

		$("#mapObj").attr("src" ,imgUrl);
        setMapObj(imgUrl,true);//spot_map_setting.js
	});
	/**
	 * 定位事件
	 * 就是关闭计时器,在重新开启
	 * 有则进行定位
	 * 否则弹窗提示
	 */
	$(".location").on("touchstart",function(){
		$(".location").addClass("imgOpacity");
		sd.loading.show("正在重新定位,请稍后......");
		event.stopPropagation();
//		$("#spotPosition").hide();//隐藏定位图标
		//重新定位 
		var positionObj = getMapPosition();//spot_position.js
		//进行定位操作
		setPosition(positionObj);//spot_position.js
		//进行移动操作
		removeMapPosition(positionObj);
		clearInterval(timer);
		sessionStorage.removeItem("autoMove");
		start();//spot_detail.js
	});
	$(".location").on("touchend",function(){
		$(".location").removeClass("imgOpacity");
	});
}
function removeMapPosition(positionObj){
	//将要移动的点
	var widthP = positionObj.elementWidth;
	var heightP = positionObj.elementHeight;
	
	//获取设备可显示区域的宽高
	var visualDivWidth = trimPX(mapVisualDiv().style.width);
	var visualDivHeight = trimPX(mapVisualDiv().style.height);
	var vDivWidthCenter = visualDivWidth/2;
	var vDivHeightCenter = visualDivHeight/2;
	//判断图片与显示窗口的关系,小图不可移动，大图可移动
	//imgWidth < visualDivWidth 判断图片与窗口的大小
	if(mapConWidth < visualDivWidth){
		mapContainer().style.left = "0px";
	}
	if(mapConHeight < visualDivHeight){
		mapContainer().style.top = "0px";
	}
	
	var mW = (widthP - vDivWidthCenter);
	if(mW > 0){
		mapContainer().style.left = (-mW)+"px";
	}else{
		mapContainer().style.left = "0px";
	}
	var mH = (heightP - vDivHeightCenter);
	if(mH > 0){
		mapContainer().style.top = (-mH)+"px";
	}else{
		mapContainer().style.top = "0px";
	}
	
	//图片与窗口边距
	var rMargin = trimPX(mapContainer().style.width) - visualDivWidth;
	if(Math.abs(trimPX(mapContainer().style.left)) > Math.abs(rMargin)){
		mapContainer().style.left = -rMargin+"px";
	}
	//图片与窗口边距
	var bMargin = trimPX(mapContainer().style.height) - visualDivHeight;
	if(Math.abs(trimPX(mapContainer().style.top)) > Math.abs(bMargin)){
		mapContainer().style.top = -bMargin+"px";
	}
	sd.loading.hide();
}
/**
 * @param {Object} scenicSpotid 景点ID
 * @param {Object} scenicSpotAudio 景点音频附件ID
 */
function playSpotAudio(scenicSpotid, scenicSpotAudio){
	//景区ID
    var scenicAreaInfo = JSON.parse(sessionStorage.getItem("scenicAreaInfo"));
	tourist.jsplayer.init({
    	scenicAreaId : scenicAreaInfo.scenicAreaid,
		scenicSpotId : scenicSpotid,
		downloadUrl : baseUrl + "/appinter/scenicspotjsop/downloadScenicSpot.do?AttachId=" + scenicSpotAudio,
		onStartPlay : function(){
			$("#playerButton").attr("src", "img/button_pause.png");
			tourist.jsplayer.showPlayStatus();
		},
		onReplay : function(){
			$("#playerButton").attr("src", "img/button_pause.png");
		},
		onPause : function(){
			$("#playerButton").attr("src", "img/button_play.png");
		},
		onUpdateProgress : function(){
			
		},
		onComplete : function(){
			$("#playerButton").attr("src", "img/button_play.png");
     		tourist.jsplayer.hidePlayStatus();
		},
		onloading : function() {
			$("#playerButton").attr("src", "img/audio_loading.gif");
		},
		onLoadError : function() {
			$("#playerButton").attr("src", "img/button_play.png");
			sd.dialog.showShort("播放失败");
		},
		onLoadComplete : function() {
			$("#playerButton").attr("src", "img/button_pause.png");
		}
    });
    
    tourist.jsplayer.play();
}

function setLevel(level){
	$(".imgLevel").attr("level", Number($(".imgLevel").attr("level"))+level);
}

function initControl(){
	//触摸控件显示
	setVideoPosition();
	//设置定位按钮控件与关闭控件
	initDetailPlayer();
}