var urls = new Array("/appinter/scenicareajsonp/listscenicarea.do?callback=?");
var count = 0;
var page = 1;
$(function() {
    sd.ui.initFooter(5, 2);
    sd.dialog.initDialog();
    initHandlebarHelper();
    initRefreshLayout();
    initSortBar();
    bindSpotList();
});

function initSortBar() {
    $('#select-button').popover({
        content : $("#selecter-template").html(),
        placement : 'bottom',
        event : "singleTap"
    }).on("show", function() {
        $("#select-button").find("b").addClass("selecting");
    }).on("hide", function() {
        $("#select-button").find("b").removeClass("selecting");
    });

    $("#selecter").find("li").each(function() {
        $(this).on("singleTap", function() {
            if ($(this).attr("css") == "selecting")
                return false;
            else {
                $("#selecter").find("li[class=selecting]").removeClass("selecting");
                $(this).addClass("selecting");
                var type = $(this).attr("type");
                resortSoptList(type);
            }
        });
    });

    var sortType = sessionStorage.getItem("sortType");

    if (!sortType) {
        sortType = "distance";
        sessionStorage.setItem("sortType", sortType);
    }

    $("#selecter").find("li[type=" + sortType + "]").addClass("selecting");

    $('.ui-refresh').refresh('this')._options.load("down", "pull");
}

function resortSoptList(type) {
    page = 1;
    $('.ui-refresh').find(".spot_list").html(null);
    sessionStorage.setItem("sortType", type);
    $('.ui-refresh').refresh('this').enable("down");
    $('.ui-refresh').refresh('this')._options.load("down", "pull");
    $('#select-button').popover('this').hide();
}

function refreshRefreshLayout() {
    $('.ui-refresh').refresh('this')._options.iScroll.refresh();
}

function initHandlebarHelper() {
    Handlebars.registerHelper("genStar", function(value) {
        if (!value)
            return "暂无评分";
        var html = "";
        value = value > 5 ? 5 : value;
        var c = (5 - value) >= 0 ? (5 - value) : 0;
        
        while (value--)
        	html += '<img src="../img/star-s.png" />';
        while (c--)
        	html += '<img src="../img/star-c.png" />';
        return html;
    });

    // 注册一个生成图片src用的Helper
    Handlebars.registerHelper("genAttachImgSrc", function(value) {
        return tourist.genAttachImgUrl(value);
    });

    //判断奇偶  生成class
    Handlebars.registerHelper("genClass", function() {
        count++;
        if (count % 2)
            return "spot_white";
        else
            return "spot_gray";
    });

    //将数字分数转换成A评级
    Handlebars.registerHelper("genMark", function(value) {
        var mark = Math.round(value);
        if (mark > 5)
            mark = 5;
        //四舍五入
        var str = "";
        while (mark-- > 0) {
            str += "A";
        }
        return str;
    });

    //将米转行成公里,四舍五入保留1位
    Handlebars.registerHelper("genDistance", function(value) {
        if (isNaN(value))
            return 0;
        else
            return Math.round(value / 100) / 10 + "km";
    });

	Handlebars.registerHelper("scenicAreaTicketStr", function(value) {
		try{
			if(typeof(this.scenicAreaTicket)=="number" || !isNaN(this.scenicAreaTicket)){//不是字符串的，判断是不是数字
				return new Handlebars.SafeString(this.scenicAreaTicket + "￥");
			}
		}catch(e){
			return new Handlebars.SafeString(this.scenicAreaTicket);
		}
		
		return new Handlebars.SafeString(this.scenicAreaTicket);
    });
}

function initRefreshLayout() {
    var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height() - $('.ui-toolbar-footer').height();
    var refreshDom = $('.ui-refresh').css("width", "100%").css("height", wrapperHeight);
    var regionInfo = JSON.parse(sessionStorage.getItem("regionInfo"));

    refreshDom.refresh({
        statechange : function(e, $elem, state, dir) {
            if (state == 'loading') {//只修改loading的状态
                e.preventDefault();
                var refreshInfo = this._options.refreshInfo[dir];
                refreshInfo['$icon'].removeClass().addClass('ui-loading');
                refreshInfo['$label'].html(dir == 'up' ? '正在刷新中...' : '数据加载中...');
            }
        },
        load : function(dir, type) {
			var params = "&regionId=" + regionInfo.regionId + "&pageSize=" + tourist.pageSize + "&page=" + page;
			if (sd.native.Map.getLocation() != null)
            	params += "&longitude=" + sd.native.Map.getLocation().longitude + "&latitude=" + sd.native.Map.getLocation().latitude;

            var sortType = sessionStorage.getItem("sortType");

            if (sortType)
                params += "&" + sortType + "=1";

            $.ajaxJSONP({
                type : "GET",
                url : baseUrl + urls[0] + params,
                beforeSend : function() {
                },
                success : function(data) {
                    page++;
                    var source = $("#spot-list-template").html();
                    var template = Handlebars.compile(source);
                    var html = template(data);
                    refreshDom.find(".spot_list").append(html);
                    $('.ui-refresh').refresh('this').afterDataLoading(dir);
                    if (!data.vo || data.vo.length < tourist.pageSize)
                        $('.ui-refresh').refresh('this').disable(dir, true);

                },
                error : function(e) {
                	$('.ui-refresh').refresh('this').afterDataLoading(dir);
                    sd.dialog.showShort("加载数据失败！");
                },
                complete : function() {
                    refreshRefreshLayout();
                }
            });
        }
    });
    $(refreshDom).css("height", "auto");
    $(refreshDom).css("overflow", "hidden");
}

function bindSpotList() {
    $(".single_spot").live('singleTap', function() {
        if ($('#select-button').popover('this')._visible)
            return false;
        var scenicAreaInfo = {
            scenicAreaid : this.id,
            scenicAreaName : $(this).find(".spot_name").html()
        };
        sessionStorage.setItem("scenicAreaInfo", JSON.stringify(scenicAreaInfo));
        window.location.href = "spot_detail.html";
    });
}

