var urls = new Array("/appinter/travelregionjsonp/listIntroduction.do?callback=?");
var count = 0;
var page = 1;
$(function() {
    sd.ui.initFooter(5, 2);
    sd.dialog.initDialog();
    initHandlebarHelper();
    initRefreshLayout();
    bindSpotList();
    initSearch();
});

function initSearch() {
    var search_txt = sessionStorage.getItem("search_txt");
    if (search_txt) {
        $("#search-input").val(search_txt);
        sd.loading.show();
        $('.ui-refresh').refresh('this')._options.load("down", "pull");
    }

    $("#btn-search").on("singleTap", function() {
        if(!$("#search-input").val()) 
        {
            sd.dialog.showShort("请输入搜索内容");
            return;
        }
        sessionStorage.setItem("search_txt", $("#search-input").val());
        $(".spot_list").html(null);
        $('.ui-refresh').refresh('this')._options.load("down", "pull");
        sd.loading.show();
    });
}

function refreshRefreshLayout() {
    $('.ui-refresh').refresh('this')._options.iScroll.refresh();
}

function initHandlebarHelper() {
    Handlebars.registerHelper("genStar", function(value) {
        if (!value)
            return "暂无评分";
        var html = "";
        var c = 5 - value;
        while (value--)
        html += '<img src="../img/star-s.png" />';
        while (c--)
        html += '<img src="../img/star-c.png" />';
        return html;
    });

    // 注册一个生成图片src用的Helper
    Handlebars.registerHelper("genAttachImgSrc", function(value) {
        return tourist.genAttachImgUrl(value);
    });

    //判断奇偶  生成class
    Handlebars.registerHelper("genClass", function() {
        count++;
        if (count % 2)
            return "spot_white";
        else
            return "spot_gray";
    });

    //将数字分数转换成A评级
    Handlebars.registerHelper("genMark", function(value) {
        var mark = Math.round(value);
        if (mark > 5)
            mark = 5;
        //四舍五入
        var str = "";
        while (mark-- > 0) {
            str += "A";
        }
        return str;
    });

    //将米转行成公里,四舍五入保留1位
    Handlebars.registerHelper("genDistance", function(value) {
        if (isNaN(value))
            return 0;
        else
            return Math.round(value / 100) / 10 + "km";
    });

}

function initRefreshLayout() {
    var wrapperHeight = $(window).height() - $('.ui-toolbar-header').height() - $('.ui-toolbar-footer').height();
    var refreshDom = $('.ui-refresh').css("width", "100%").css("height", wrapperHeight);
    var regionInfo = JSON.parse(sessionStorage.getItem("regionInfo"));

    refreshDom.refresh({
        statechange : function(e, $elem, state, dir) {
            if (state == 'loading') {//只修改loading的状态
                e.preventDefault();
                var refreshInfo = this._options.refreshInfo[dir];
                refreshInfo['$icon'].removeClass().addClass('ui-loading');
                refreshInfo['$label'].html(dir == 'up' ? '正在刷新中...' : '数据加载中...');
            }
        },
        load : function(dir, type) {
        	var params = "";
        	if (sd.native.Map.getLocation() != null)
           		params = "&longitude=" + sd.native.Map.getLocation().longitude + "&latitude=" + sd.native.Map.getLocation().latitude;

            var search_txt = sessionStorage.getItem("search_txt");
            if (search_txt)
                params += "&scenicAreaName=" + encodeURI(encodeURI(search_txt));

            $.ajaxJSONP({
                type : "GET",
                url : baseUrl + urls[0] + params,
                beforeSend : function() {
                },
                success : function(data) {
                    page++;
                    var source = $("#spot-list-template").html();
                    var template = Handlebars.compile(source);
                    var html = template(data);
                    refreshDom.find(".spot_list").append(html);
                    $('.ui-refresh').refresh('this').afterDataLoading(dir);
                },
                error : function(e) {
                    sd.dialog.showShort("连接超时！");
                },
                complete : function() {
                    sd.loading.hide();
                    refreshRefreshLayout();
                }
            });
        }
    });
    $(refreshDom).css("height", "auto");
    $(refreshDom).css("overflow", "hidden");
    $(".ui-refresh-wrapper").css("background-color", "white");
    $('.ui-refresh').refresh('this').disable("down", true);
}

function bindSpotList() {
    $(".single_spot").live('singleTap', function() {
        if ($('#select-button').popover('this')._visible)
            return false;
        var scenicAreaInfo = {
            scenicAreaid : this.id,
            scenicAreaName : $(this).find(".spot_name").html()
        };
        sessionStorage.setItem("scenicAreaInfo", JSON.stringify(scenicAreaInfo));
        window.location.href = "spot_detail.html";
    });
}

