/*-
 * 进行地标换算
 */
//-----------设置全局参数--------
/**
 * gis_x : 经度换算比例
 * gis_y : 纬度换算比例
 * length : 数据长度
 */
var gis_x = 0;
var gis_y = 0;
var length = 0;
//定义一个定位对象
var thePosition = ["elementHeight","elementWidth","latitude","longitude","spotAudio","spotId","spotName"];
var debug = false;
//图片距离差，调整定位中心位置（图片大小30*30）
var pic = {"disX":30,"disY":30};
//var pic = {"disX":0,"disY":0};
var arrI = 0;

//复制origin原数据，防止改变原数据  	gisParam = $.extend(true, [], origin);
var gisParam = [];
/**
 * newHeightParam ：纬度从小到大排序参数
 * newWidthParam ： 经度从小到大排序参数
 */
var newHeightParam = [];
var newWidthParam = [];

//通过最大最小的值进行读取的
function getNowPosition(nowPosition){
	nowPosition.elementWidth = Math.ceil(rightBottom.elementWidth - gis_x*(rightBottom.longitude - nowPosition.longitude)) ;
	nowPosition.elementHeight = Math.ceil(leftTop.elementHeight - gis_y*(leftTop.latitude - nowPosition.latitude)) ;
	console.info("name;"+nowPosition.spotName)
	//进行绝对值换算并且获取图片的左边距与上边距
	return nowPosition;
}
//设置定位
function setPosition(nowPosition){

	//进行位置与图片大小判断
	if(nowPosition.elementWidth > mapConWidth || nowPosition.elementHeight > mapConHeight || nowPosition.elementWidth<0 || nowPosition.elementHeight<0){
		$("#spotPosition").css("display","none");
//		sd.dialog.showLong("位置不在当前景区内,请重新定位");
		return ;
	}else{
		//如果位置换算由js，则下面一行代码需要删除
		rateXY = 1;
		$("#spotPosition").css("display","block");
		$("#spotPosition").css("left",(nowPosition.elementWidth - pic.disX*rateXY)+"px").css("top",(nowPosition.elementHeight - pic.disY*rateXY)+"px");
			//获取到当前图片的位置
		var point = {"x":nowPosition.elementWidth,"y":nowPosition.elementHeight};
		if(debug){
			//自动定位时自动播放
			autoPlayOrShowControl(point , false);
		}else{
			autoPlayOrShowControl(point , true);
		}
	}
	
}
//这是换算gis中的x与y的比例
/**
 * 以最远的高与宽、经纬度差算出每经纬度的像素值
 * leftTop ： 图片左上点或者是通过获取到的模拟后的左上点（模拟可非顶点）
 * rightBottom : 图片右下点或者是通过获取到的模拟后的右下点（模拟可非顶点）
 */
function getScale_Gis(){
	gis_x = (rightBottom.elementWidth - leftTop.elementWidth)/(rightBottom.longitude - leftTop.longitude);
	gis_y = (leftTop.elementHeight - rightBottom.elementHeight)/(leftTop.latitude - rightBottom.latitude);
	console.info("gis_x:"+gis_x+",gis_y:"+gis_y)
}

/**
 * 冒泡排序
 * 获取从小到大的顺序
 * @param {Object} ele ： 数组对象中对比元素名
 */
function getNewParam(ele){
	for(var i=0;i<=	gisParam.length-1;i++){
		for(j = i;j<=gisParam.length-1;j++){
			if(gisParam[i][ele] > gisParam[j][ele]){
				var obj = gisParam[i];
				gisParam[i] = gisParam[j];
				gisParam[j] = obj;
			}
		}
	}
	return gisParam;
}
/**
 * 获取参考点的参数
 * origin : 表示图片上的景点像素值以对应对应景点的参数
 * 还有图片放大时从spot_map_scale.js重新赋值
 * 原理：
 * 	1.如果有提供图片左上与右下顶点数据，则进行顶点换算比例操作
 * 	2.如果是没有提供顶点数据，则分别取最远的经纬度点组成新的两个顶点（此两个新的点未必是景区的景点数据）
 */
function getReferencePosition(){
//	if(isAutoPlay){
	if(leftTop.length == 0 || rightBottom.length == 0 || rightBottom == null || leftTop == null){
		if(origin != null && origin.length >= 2){
			gisParam = $.extend(true, [], origin);
			newHeightParam = $.extend(true, [] , getNewParam("latitude"));
			newWidthParam = $.extend(true, [] , getNewParam("longitude"));
		}
		leftTop.longitude = newWidthParam[0].longitude;
		leftTop.elementWidth = newWidthParam[0].elementWidth;
		leftTop.latitude = newHeightParam[length].latitude;
		leftTop.elementHeight = newHeightParam[length].elementHeight;
		
		rightBottom.longitude = newHeightParam[length].longitude;
		rightBottom.elementWidth = newHeightParam[length].elementWidth;
		rightBottom.latitude = newWidthParam[0].latitude;
		rightBottom.elementHeight = newWidthParam[0].elementHeight;
		
	}else{
		leftTop.elementWidth = 0;
		leftTop.elementHeight = 0;
		rightBottom.elementWidth = mapConWidth;
		rightBottom.elementHeight = mapConHeight;
	}
	
}
/**
 * 获取当前GPS的经纬度坐标
 */
function getMapPosition(){
	var positionObj = null;
	if(debug){
		thePosition = [
			{"elementHeight":"472.65625","elementWidth":"304.6875","longitude":"113.305105","latitude":"23.11994","spotId":"402883b34ed37af2014ed416abbc0001","spotName":"广州酒类专卖店"}
			,{"elementHeight":"250.0","elementWidth":"355.46875","longitude":"113.305197","latitude":"23.119917","spotAudio":"4a8accf24ed39f5a014ee35cee5e000d","spotId":"4a8accf24ec3504d014ec5530a21001d","spotName":"泰恒大厦"}
			,{"elementHeight":"260.15625","elementWidth":"851.5625","latitude":"23.122481","longitude":"113.308897","spotAudio":"4a8accf24ed39f5a014ee35e9b4a0017","spotId":"4a8accf24ec3504d014ec55a25d80022","spotName":"五羊邨地铁站"}
			,{"elementHeight":"246.09375","elementWidth":"281.25","latitude":"23.122524","longitude":"113.302130","spotAudio":"4a8accf24ed39f5a014ee35c7bea000b","spotId":"4a8accf24ec3504d014ec552306b001c","spotName":"长城酒店"}
			,{"elementHeight":"242.1875","elementWidth":"203.125","latitude":"23.122590","longitude":"113.301327","spotAudio":"4a8accf24ed39f5a014ee35c38d60009","spotId":"4a8accf24ec3504d014ec5513698001b","spotName":"人防大厦"}
			,{"elementHeight":"250.0","elementWidth":"515.625","latitude":"23.122601","longitude":"113.304814","spotAudio":"4a8accf24ed39f5a014ee35d8ddc0011","spotId":"4a8accf24ec3504d014ec555aaa4001f","spotName":"渤海银行"}
			,{"elementHeight":"250.0","elementWidth":"433.59375","latitude":"23.122634","longitude":"113.303902","spotAudio":"4a8accf24ed39f5a014ee35d35e0000f","spotId":"4a8accf24ec3504d014ec553c98c001e","spotName":"恒生银行"}
			,{"elementHeight":"232.8125","elementWidth":"129.6875","latitude":"23.122674","longitude":"113.300433","spotAudio":"4a8accf24ed39f5a014ee35be7ef0007","spotId":"4a8accf24ec3504d014ec54ffa58001a","spotName":"百果园"}
			,{"elementHeight":"226.5625","elementWidth":"58.59375","latitude":"23.122748","longitude":"113.299670","spotAudio":"4a8accf24ed39f5a014ee35b92b80005","spotId":"4a8accf24ec3504d014ec54ea2ce0019","spotName":"华友大厦"}
			,{"elementHeight":"238.28125","elementWidth":"660.15625","latitude":"23.122766","longitude":"113.306571","spotAudio":"4a8accf24ed39f5a014ee35de7590013","spotId":"4a8accf24ec3504d014ec55661560020","spotName":"中国银行"}
			,{"elementHeight":"222.65625","elementWidth":"742.1875","latitude":"23.122833","longitude":"113.307514","spotAudio":"4a8accf24ed39f5a014ee35e511a0015","spotId":"4a8accf24ec3504d014ec557255c0021","spotName":"邮政储蓄银行"}
			,{"elementHeight":"31.25","elementWidth":"882.8125","latitude":"23.124969","longitude":"113.309038","spotId":"402883b34ed37af2014ed41733f20002","spotName":"南方传媒大厦"}
		];
		positionObj = getNowPosition(thePosition[arrI]);
		if(arrI >= thePosition.length-1){
			arrI = 8;
	//		clearInterval(timer);
		}else{
			arrI = 8;
		}
	}else{
		var locationObj = sd.native.Map.getLocation();
		if (locationObj == null)  {
			sd.loading.hide();
			sd.dialog.showShort("获取您的位置失败，请检测GPS设置！");
			return;
		}
		thePosition.longitude = locationObj.longitude;
		thePosition.latitude = locationObj.latitude;
		positionObj = getNowPosition(thePosition);
	}
	return positionObj;
}
/**
 * 定时器，时时定时
 */
function start(){
	var obj = getMapPosition();
	if(obj.elementWidth > mapConWidth || obj.elementHeight > mapConHeight || obj.elementWidth<0 || obj.elementHeight<0){
		$("#spotPosition").css("display","none");
		sd.dialog.showLong("位置不在当前景区内,请重新定位");
		return ;
	}
	timer = setInterval(function(){
		//获取当前经纬度与图片的坐标
		var obj = getMapPosition();
		//进行定位操作
		setPosition(obj);
		//触碰屏幕不自行定位移动，点击定位按钮又重开始移动
		if(sessionStorage.getItem("autoMove") == null? true: false){
			//移动图片与屏幕相对位置
			removeMapPosition(obj);//spot_detail_player.js
		}
	},3000);
}

/**
 * 初始化数据长度，参考点，经纬度换算比例
 */
function initMap() {
	length = origin.length-1;
	//传入两组
	getReferencePosition();//··获取当前参考点
	getScale_Gis();//这是换算gis中的x与y的比例
}
